=== debian/changelog ===
inotify-info (0.0.2-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0.0.2.
  * Removing march.patch, not needed anymore.
  * Removing dwz.patch, not needed anymore.
  * Setting INOTIFYINFO_VERSION to debian package version.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 03 Jun 2024 22:01:31 +0200

inotify-info (0.0.1-2) sid; urgency=medium

  * Uploading to sid.
  * Building without -march=native (Closes: #1071076).
  * Refreshing dwz.patch.
  * Renumbering patches.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 18 May 2024 14:41:59 +0200

inotify-info (0.0.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 0.0.1.
  * Using codename instead of suitname in changelog.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 05 May 2024 13:02:50 +0200

inotify-info (0~20240209-1) sid; urgency=medium

  * Initial upload to sid.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 25 Apr 2024 09:14:44 +0200
