=== debian/rules ===
#!/usr/bin/make -f

export INOTIFYINFO_VERSION = $(shell dpkg-parsechangelog -SVersion)

%:
	dh ${@}

execute_after_dh_auto_clean:
	rm -rf _release
