## inotify-info 0.0.3

=== debian/changelog ===
inotify-info (0.0.3-4) sid; urgency=medium

  * Simplifying watch file.

 -- Daniel Baumann <daniel@debian.org>  Fri, 02 May 2025 07:53:11 +0200

inotify-info (0.0.3-3) sid; urgency=medium

  * Updating to standards version 4.7.1.
  * Updating to standards version 4.7.2.

 -- Daniel Baumann <daniel@debian.org>  Wed, 19 Mar 2025 20:44:36 +0100

inotify-info (0.0.3-2) sid; urgency=medium

  * Updating source url in copyright.
  * Updating vcs fields.
  * Updating email address.
  * Trimming debian changelog.
  * Updating year in debian copyright for 2025.

 -- Daniel Baumann <daniel@debian.org>  Wed, 05 Feb 2025 15:54:20 +0100

inotify-info (0.0.3-1) sid; urgency=medium

  * Merging upstream version 0.0.3.
  * Removing manual debhelper install file, not needed anymore with new
    upstream version.
  * Enabling non-silent output during build.

 -- Daniel Baumann <daniel@debian.org>  Sat, 13 Jul 2024 13:02:30 +0200
