=== debian/control ===
Source: inotify-info
Section: utils
Priority: optional
Maintainer: Daniel Baumann <daniel@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/mikesart/inotify-info
Vcs-Browser: https://forgejo.debian.net/linux/inotify-info
Vcs-Git: https://forgejo.debian.net/linux/inotify-info

Package: inotify-info
Section: utils
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: tracking the number of inotify watches
 The Linux inotify system can be difficult to debug when the system runs out of
 watches. inotify-info allows tracking down how many inotify watches, instances,
 and which files are being watched.
