=== debian/rules ===
--- 
+++ 
@@ -7,3 +7,9 @@
 
 execute_after_dh_auto_clean:
 	rm -rf _release
+
+override_dh_auto_build:
+	dh_auto_build -- VERBOSE=1
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=$(CURDIR)/debian/inotify-info/usr
