=== debian/watch ===
version=4
https://github.com/mikesart/inotify-info/tags .*/v?(\d.*)@ARCHIVE_EXT@
